/***************************************************************************
 *  Copyright:http://www.naradabrokering.org/index.html
 *  Author: Jaliya Ekanayake
 *  Email : jaliyae@gmail.com
 ****************************************************************************/
#ifndef AGENTDISCOVERYREQUEST_H_
#define AGENTDISCOVERYREQUEST_H_

#include <string>
#include <iostream>

#include "openssl/x509.h"
#include "openssl/pem.h"
#include "openssl/bio.h"
#include "openssl/err.h"
#include <sys/types.h>

#include "NBCMessage.h"

using namespace std;

class AgentDiscoveryRequest : public NBCMessage
{
	public:
		AgentDiscoveryRequest();
		~AgentDiscoveryRequest();
		
		
		bool fromBytes(char *bytes);
		void getBytes(char *buff,int *length);
		int getSerializedLength();	
		
		string getRequestId(){
			return this->requestId;
		}
		
		void setRequestId(string requestId){
			this->requestId=requestId;
			this->hasRequestId=true;
		}
		
		bool isHasRequestId(){
			return hasRequestId;
		}
		
	private:
	
	const static int SIZE_OF_MSG = 128;
	string requestId;
	bool hasRequestId;
		

};

#endif /*AGENTDISCOVERYREQUEST_H_*/
