/***************************************************************************
 *  Copyright:http://www.naradabrokering.org/index.html
 *  Author: Jaliya Ekanayake
 *  Email : jaliyae@gmail.com
 ****************************************************************************/
#ifndef AGENTDISCOVERYRESPONSE_H_
#define AGENTDISCOVERYRESPONSE_H_

#include <string>
#include <iostream>

#include "openssl/x509.h"
#include "openssl/pem.h"
#include "openssl/bio.h"
#include "openssl/err.h"
#include <sys/types.h>

#include "NBCMessage.h"



using namespace std;

class AgentDiscoveryResponse : public NBCMessage
{
	public:
		AgentDiscoveryResponse();
		~AgentDiscoveryResponse();	
		
		bool fromBytes(char *bytes);
		void getBytes(char *buff,int *length);
		int getSerializedLength();	
		void getAgentCertificate(X509 ** cert);
		void setAgentCertStr(string agent_cert);
		
		void setAgentId(string agentId);
		string getAgentId();
		
		void getACopy(AgentDiscoveryResponse *res);
		
		
		
	private:
	 const static int SIZE_OF_MSG = 256;
	 string agentId;
	 string agent_cert;
};


#endif /*AGENTDISCOVERYRESPONSE_H_*/
