/***************************************************************************
 *  Copyright:http://www.naradabrokering.org/index.html
 *  Author: Jaliya Ekanayake
 *  Email : jaliyae@gmail.com
 ****************************************************************************/
#ifndef ENCRYPTEDCOVERMESSAGE_
#define ENCRYPTEDCOVERMESSAGE_
#include <string>
#include <iostream>

#include "openssl/x509.h"
#include "openssl/pem.h"
#include "openssl/bio.h"
#include "openssl/err.h"
#include <sys/types.h>

#include "NBCMessage.h"

using namespace std;

class EncryptedCoverMessage : public NBCMessage
{
	public:
		EncryptedCoverMessage();
		~EncryptedCoverMessage();
		
		
		bool fromBytes(char *bytes);
		void getBytes(char *buff,int *length);
		
		int getSerializedLength();	
		
		char *getMessage(){
			return this->message;
		}
		
		void setMessage(char *message, int length){
			this->message=message;
			this->messageLength=length;
		}
		
		char *getSecretKey(){
			return this->secretKey;
		}
		
		void setSecretKey(char *key, int length){
			this->secretKey=key;
			this->secretKeyLength=length;
		}
		
		int getSecretKeyLength(){
			return this->secretKeyLength;
		}
		
		int getMessageLength(){
			return this->messageLength;
		}
		
		
	private:
		char *message;
		int messageLength;
		char *secretKey;
		int secretKeyLength;
		const static int HEADER_SIZE=32;
		bool deletable;	
		

};
#endif /*ENCRYPTEDCOVERMESSAGE_*/
