/***************************************************************************
 *  Copyright:http://www.naradabrokering.org/index.html
 *  Author: Jaliya Ekanayake
 *  Email : jaliyae@gmail.com
 ****************************************************************************/
#ifndef NBCENVELOPE_H_
#define NBCENVELOPE_H_

#include <string>
#include <iostream>

#include "openssl/x509.h"
#include "openssl/pem.h"
#include "openssl/bio.h"
#include "openssl/err.h"
#include <sys/types.h>

#include "NBCMessage.h"

using namespace std;

class NBCEnvelope :public NBCMessage
{
	public:
		NBCEnvelope();
		~NBCEnvelope();	
		
		bool isSecure(){
			return secure;
		}
		
		void setSecure(bool secure){
			this->secure=secure;
		}		
		
		char *getPayload(){
			return this->payload;
		}
		
		void setPayload(char *payload, int length){
			this->payload=payload;
			this->payload_length=length;
		}
	
		char *getSignature(){
			return this->signature;
		}
		
		void setSignature(char *signature,int length){
			this->signature=signature;
			this->signature_length=length;
		}
		
		void setCertString(string cert, int length){
			/*Keep a copy in a char array*/
			this->cert=new char[length];
			memcpy(this->cert,cert.c_str(),length);	
			this->cert_length=length;
		}
		
		string getCertString(){
			return this->cert;
		}
		
		int getSignatureLength(){
			return this->signature_length;
		}
		
		int getPayloadLength(){
			return this->payload_length;
		}
		
		int getCertLength(){
			return this->cert_length;
		}
		
		
		bool fromBytes(char *bytes);
		
		 /** Get a byte stream representation of the event */
		 void getBytes(char *buff,int *length);  		
		 void getCertificate(X509 ** cert);
		 
		 int getSerializedLength();	
		
		
	private:
	    bool secure ;
	    char *payload;
	    int payload_length;
	    char *cert;
	    int cert_length;
	    char *signature;
	    int signature_length;	
	    
	    const static int SIZE_OF_MSG=128;

};


#endif /*NBCENVELOPE_H_*/
