/***************************************************************************
 *  Copyright:http://www.naradabrokering.org/index.html
 *  Author: Jaliya Ekanayake
 *  Email : jaliyae@gmail.com
 ****************************************************************************/
#ifndef SERVICEDISCOVERYREQUEST_H_
#define SERVICEDISCOVERYREQUEST_H_

#include <string>
#include <iostream>

#include "openssl/x509.h"
#include "openssl/pem.h"
#include "openssl/bio.h"
#include "openssl/err.h"
#include <sys/types.h>

#include "NBCMessage.h"

using namespace std;

class ServiceDiscoveryRequest : public NBCMessage
{
	public:
		ServiceDiscoveryRequest();
		~ServiceDiscoveryRequest();
		
		
		bool fromBytes(char *bytes);
		void getBytes(char *buff,int *length);
		int getSerializedLength();	
		
		string getRequestId(){
			return this->requestId;
		}	
		
		void setRequestId(string requestId){
			this->requestId=requestId;			
		}		
				
		string getServiceDescription(){
			return this->serviceDescription;
		}	
		
		void setServiceDescription(string serviceDescription){
			this->serviceDescription=serviceDescription;		
		}
		
	private:
	
	const static int SIZE_OF_HEADERS = 16;
	string requestId;	
	
	/*Service Description is a must*/
	string serviceDescription;
	
		

};


#endif /*SERVICEDISCOVERYREQUEST_H_*/

