/***************************************************************************
 *  Copyright:http://www.naradabrokering.org/index.html
 *  Author: Jaliya Ekanayake
 *  Email : jaliyae@gmail.com
 ****************************************************************************/
#ifndef SERVICEDISCOVERYRESPONSE_H_
#define SERVICEDISCOVERYRESPONSE_H_
#include <string>
#include <iostream>
#include <vector>

#include "openssl/x509.h"
#include "openssl/pem.h"
#include "openssl/bio.h"
#include "openssl/err.h"
#include <sys/types.h>

#include "NBCMessage.h"

using namespace std;

class ServiceDiscoveryResponse : public NBCMessage
{
	public:
		ServiceDiscoveryResponse();
		~ServiceDiscoveryResponse();
		
		
		bool fromBytes(char *bytes);
		void getBytes(char *buff,int *length);
		int getSerializedLength();			
		
		int getNumServiceDescriptions(){
			return this->serviceDescriptions.size();
		}		
		
		vector<string> getServiceDescriptions(){
			return this->serviceDescriptions;
		}	
		
		void addServiceDescription(string serviceDescription){
			this->serviceDescriptions.push_back(serviceDescription);		
		}
		
	private:

	/*Service Description is a must*/
	vector<string> serviceDescriptions;
	
		

};

#endif /*SERVICEDISCOVERYRESPONSE_H_*/
