/***************************************************************************
 *  Copyright:http://www.naradabrokering.org/index.html
 *  Author: Jaliya Ekanayake
 *  Email : jaliyae@gmail.com
 ****************************************************************************/

//Simple demonstration of how to use NaradaBrokering's C++ client with 
//ROOT framework. This chat client utilizes the publish/subscribe 
//messaging capabilities of NaradaBrokering.


#include <iostream>

#define NB_BROKER_HOST "156.56.104.95"
#define NB_BROKER_PORT 5045
#define NB_TEMPLATE_ID 12345

using namespace std;

class SimpleClient {
	RQ_OBJECT("SimpleClient")

private:
	string chatTopic;
	void * tServiceClient;
	void * tCallback;

public:
	SimpleClient(string topic);
	virtual ~SimpleClient();
	void Send(char *bytes,int length);
	void Callback(void **v, char *bytes, int length);
};

SimpleClient::SimpleClient(string topic):chatTopic(topic) {
	srand((unsigned) time(0));
	int entityID = (rand() % 8000) + 8000;

	tServiceClient=(TServiceClient *)(new TServiceClient());
	((TServiceClient *)tServiceClient)->Init(NB_BROKER_HOST,NB_BROKER_PORT,entityID,NB_TEMPLATE_ID);

	void **args=new void *[10]; //This can be used to pass any number of references 
	//to the callback method. Here we don't need anything.

	tCallback=new TCallback();
	((TCallback *)tCallback)->registerCallback(args,
			"SimpleClient", "Callback");
	((TServiceClient *)tServiceClient)->Subscribe(chatTopic
			,tCallback);
			cout<<"Subscribed to response topic: "<<chatTopic<<endl;
}

SimpleClient::~SimpleClient(){
		
}

SimpleClient::Callback(void **v, char *bytes, int length) {
	//Assume the message is a chat message
	string msg(bytes, length);
	cout<<"Received : "<<msg<<endl;
}

void
SimpleClient::Send(char *bytes, int length) {
	((TServiceClient *)tServiceClient)->Publish(chatTopic,bytes,length);
}

void SimpleClient() {
	
	gDebug = kFALSE;
	gSystem->Load("libnbROOT.so");	
	
	cout<<"====================Simple Chat Client============="<<endl;
	cout<<"Type a messages and press <return key>"<<endl;
	cout<<"To exit type .<return key>"<<endl;
	cout<<"==================================================="<<endl;
	
	string chatToic="/test/clarens/hep";
	
	SimpleClient *sc=new SimpleClient(chatToic);
			
	char msg[256]="";
	string str="";
	while (str!=".") {
		cin.getline(msg, 256);
		str=msg;
		if (!(str==".")) {
			for (int i=0; i<1; i++) {
				sc->Send(msg, strlen(msg));
			}
		}
	}
}