/***************************************************************************
 *  Copyright:http://www.naradabrokering.org/index.html
 *  Author: Jaliya Ekanayake
 *  Email : jaliyae@gmail.com
 ****************************************************************************/
#include "AgentDiscoveryRequest.h"
#include "constants.h"
#include "Utils.h"

AgentDiscoveryRequest::AgentDiscoveryRequest():hasRequestId(false){}

AgentDiscoveryRequest::~AgentDiscoveryRequest(){	
}


int 
AgentDiscoveryRequest::getSerializedLength(){
	return SIZE_OF_MSG;
}	

void 
AgentDiscoveryRequest::getBytes(char *buff,int *length)
{
	 long long offset = 0;
	 Utils::writeByte(buff+offset,(char)CLARENS_DATA,offset);
     Utils::writeByte(buff+offset,(char)NB_CLARENS_MESSAGE,offset);
     
     Utils::writeBool(buff+offset,this->hasRequestId,offset);
     
     Utils::writeInt(buff+offset,requestId.length(),offset);
     //cout<<"Lenght of the request ID @ AgentDiscoveryRequest::getBytes" <<requestId.length()<<endl;
     Utils::writeBytes(buff+offset,requestId.c_str(),requestId.length(),offset);     
    
     //Now set the length
     (*length)=offset;          

}

 bool 
 AgentDiscoveryRequest::fromBytes(char *bytes){
 	 long long offset = 0;
 	  	
 	//Validate the first two bytes
 	if(CLARENS_DATA!=Utils::readByte(bytes+offset,offset)) {return false;} ;
	if(NB_CLARENS_MESSAGE!=Utils::readByte(bytes+offset,offset)) {return false;};
	
	//Now read the egentId
	this->hasRequestId = Utils::readBool(bytes+offset,offset);
	
	int requestIdLength=Utils::readInt(bytes+offset,offset);
	
	char id[requestIdLength];
	Utils::copyBytes((bytes+offset),id,requestIdLength,offset);
	this->requestId.assign(id,requestIdLength);	
	return true;
	
 }
