/***************************************************************************
 *  Copyright:http://www.naradabrokering.org/index.html
 *  Author: Jaliya Ekanayake
 *  Email : jaliyae@gmail.com
 ****************************************************************************/
#include "AgentDiscoveryResponse.h"
#include "constants.h"
#include "Utils.h"
#include "SecurityException.h"
#include "ServiceException.h"


AgentDiscoveryResponse::AgentDiscoveryResponse(){}

AgentDiscoveryResponse::~AgentDiscoveryResponse(){	
}

void
AgentDiscoveryResponse::setAgentId(string agentId)
{
	this->agentId=agentId;
}

string
AgentDiscoveryResponse::getAgentId()
{
	return this->agentId;
}

/*
 * Returns the certificate of the discoverd agent.
 * */
void 
AgentDiscoveryResponse::getAgentCertificate(X509 **cert) 
{
	
	
		 //X509 *x;
	 unsigned char *buf, *p;
	
	 int length;
	
	 /* Something to setup buf and len */
	 buf=(unsigned char *)this->agent_cert.c_str();
	 length=this->agent_cert.length();
	
	 p = buf;
	
	 (*cert) = d2i_X509(NULL, (const unsigned char **)&p, length);
	
	 if ((*cert) == NULL){
		 cout<<"$$$$$$$$$Error in getting the certificate "<<endl;
	 }
	
	/*OLD CODE 
	
	
	int len=-1;
	BIO *bio =BIO_new(BIO_s_mem());	
	//cout<<"Agent's Certificate "<<agent_cert.c_str()<<endl<<"Agent's Certificate Length = "<<agent_cert.length()<<endl<<endl;
	len=BIO_write(bio,this->agent_cert.c_str(),this->agent_cert.length());
	
	if(len==-1)	{
		cout<<"BIO_write @ AgentDiscoveryResponse::getAgentCertificate"<<endl;
		throw SecurityException("BIO_write @ AgentDiscoveryResponse::getAgentCertificate");
	}
	
	*cert = PEM_read_bio_X509(bio, NULL, NULL, NULL);
	
	if (! (*cert)) {
		cout<<"ERROR: PEM_read_bio_X509 @ AgentDiscoveryResponse::getAgentCertificate"<<endl;
       throw SecurityException("ERROR: PEM_read_bio_X509 @ AgentDiscoveryResponse::getAgentCertificate");
    }	
		
	if(bio) BIO_free(bio);
	*/
 	
}

void 
AgentDiscoveryResponse::setAgentCertStr(string agent_cert)
{
	this->agent_cert=agent_cert;
}	

int 
AgentDiscoveryResponse::getSerializedLength(){
	return this->agent_cert.size()+SIZE_OF_MSG;
}	

void 
AgentDiscoveryResponse::getACopy(AgentDiscoveryResponse *res){
	 res->setAgentCertStr(this->agent_cert);
	 res->setAgentId(this->agentId);
}

void 
AgentDiscoveryResponse::getBytes(char *buff,int *length)
{
	 long long offset = 0;
	 Utils::writeByte(buff+offset,(char)CLARENS_DATA,offset);
     Utils::writeByte(buff+offset,(char)NB_CLARENS_MESSAGE,offset);
     
     Utils::writeInt(buff+offset,agentId.length(),offset);
     Utils::writeBytes(buff+offset,agentId.c_str(),agentId.length(),offset);
     
     Utils::writeInt(buff+offset,agent_cert.length(),offset);
     Utils::writeBytes(buff+offset,agent_cert.c_str(),agent_cert.length(),offset);
     //Now set the length
     (*length)=offset;    
}

 bool 
 AgentDiscoveryResponse::fromBytes(char *bytes){
 	long long offset = 0;
 	  	
 	//Validate the first two bytes
 	if(CLARENS_DATA!=Utils::readByte(bytes+offset,offset)) {return false;} ;
	if(NB_CLARENS_MESSAGE!=Utils::readByte(bytes+offset,offset)) {return false;} ;
	
	//Now read the egentId
	int agentIdLength = Utils::readInt(bytes+offset,offset);
	
	char id[agentIdLength];
	Utils::copyBytes((bytes+offset),id,agentIdLength,offset);
		
	this->agentId.assign(id,agentIdLength);
		 
	//Reading the agent's certificate
	int agentCertLength = Utils::readInt(bytes+offset,offset);
	
	char cert[agentCertLength];
	Utils::copyBytes((bytes+offset),cert,agentCertLength,offset);
	this->agent_cert.assign(cert,agentCertLength);	
	//cout<<"Agent's certificate while reading ="<<agent_cert.c_str()<<endl;
	return true;
 }
 
 /**
  * Testing procedure
  * 
  * */
 
 /*
  AgentDiscoveryResponse adrMsg;
		adrMsg.setAgentId("aaaaaaaabbbbbbb");
		adrMsg.setAgentCertStr(rsa->getUserCert());
		
		char buf[rsa->getUserCert().length()+256];
		int len;
		adrMsg.getBytes(buf,&len);
		
		AgentDiscoveryResponse aMsg;
		aMsg.fromBytes(buf);
		cout<<aMsg.getAgentId()<<endl;
		
		X509 *cert = NULL;
		aMsg.getAgentCertificate(&cert);	
		
		//Have to check from here
				
		cout<<"Coming to this place"<<endl;
	
		if(cert==NULL)
			cout<<"ERROR : Could not get the certificate from the de-serilaized object"<<endl;
				
		BIO *bio =BIO_new(BIO_s_mem());	
		if (!PEM_write_bio_X509(bio, cert))
        {
        	cout<<"ERROR : PEM_write_bio_X509 at AgentServiceClient "<<endl;
        	exit(-1);
        }        
      	
        	
        		
		
		string m_cert="";		
		
		char buff[32];
		bool finished=false;
		while(!finished){
			BIO_read(bio,buff,32);		
			string cert_line(buff);			
			//cout<<cert_line<<endl;	
			
			m_cert+=cert_line.substr(0,32);	
	      
	       size_t index=m_cert.find("-----END CERTIFICATE-----",0);
	       if((size_t !=string::npos)){
	       	 finished=true;
	       	 m_cert.substr(0,index+25);
	       
	       }  
	       || 
           (m_cert.find("-----END X509 CERTIFICATE-----",0) !=string::npos)){
           	
           }				
			
		}
	
		cout<<m_cert<<endl;	
   
  */
 
 

