/***************************************************************************
 *  Copyright:http://www.naradabrokering.org/index.html
 *  Author: Jaliya Ekanayake
 *  Email : jaliyae@gmail.com
 ****************************************************************************/
#include <iostream>
#include <fstream>
#include "ServiceClient.h"
#include "Profile.h"
#include "Utils.h"

using namespace std;

int main(int argc, char **argv) {
	cout<<"///////////////////////TestClient////////////////////////"<<endl;
	cout<<argc<<endl;
	if (argc!=6) {
		cout<<"Usage : [host][port][topic][file name][wait milliseconds]"<<endl;
		exit(1);
	}
	/*Ignore the first argument */
	*argv++;

	/*host*/
	string host=*argv++;

	/*port*/
	int port=0;
	std::istringstream ss_port(*argv++);
	ss_port>>port;

	srand((unsigned) time(0));
	int entityId = (rand() % 10000) + 10000;
		
	string contentSynopsis=*argv++;

	string fileName=*argv++;
	
	int wait_milis=0;
	std::istringstream ss_wm(*argv++);
	ss_wm>>wait_milis;

	if ( contentSynopsis.length()<=0 ||fileName.length()<=0||wait_milis<=0) {
		cout<<"Usage : [host][port][topic][file name][wait milliseconds]"<<endl;
		exit(1);
	}

	int templateId=55745;
	ifstream::pos_type size;
	char * memblock;

	ifstream file(fileName.c_str(), ios::in|ios::binary|ios::ate);
	if (file.is_open()) {
		size = file.tellg();
		int new_size=(int)size+16;//16 to  carry time.
		memblock = new char [new_size];
		
		long long offset=0;
		
		long long time=Utils::getCurrentTimeMicroseconds();		
		Utils::writeLong(memblock+offset, time, offset);
				
		file.seekg(0, ios::beg);
		file.read(memblock+offset, size);
		file.close();	
		

		//cout << "the complete file content is in memory";
		ServiceClient serviceClient;
		serviceClient.init(host, port, entityId, templateId);
		//cout<<"Publishing = "<<contentSynopsis<<"   "<<fileName<<endl;
		
		while(true){
			offset=0;
			time=Utils::getCurrentTimeMicroseconds();		
			Utils::writeLong(memblock+offset, time, offset);
			serviceClient.publish(contentSynopsis,memblock,new_size);
			usleep(wait_milis*1000);
		}

		delete[] memblock;
		serviceClient.cleanup();
	} else {
		cout << "Unable to open file";
	}

	//string txt="This is my text message ";
	//serviceClient.publish(contentSynopsis,(char *)txt.c_str(),txt.length());	

}
