/***************************************************************************
 *  Copyright:http://www.naradabrokering.org/index.html
 *  Author: Jaliya Ekanayake
 *  Email : jaliyae@gmail.com
 ****************************************************************************/
#include <iostream>
#include "ServiceClient.h"
#include "Profile.h"
#include "Utils.h"

using namespace std;

#define PRINT_COUNT 500
#define TO_MILLIS 1000

#define ARRAY_SIZE 100
#define START_COUNT 50



class MyCallback : public Callback
{
	public:
	MyCallback()
		:totalTime(0),count(0)
	{}
	
	void onEvent(NBEvent *nbEvent){
		this->count++;
		//cout<<count<<endl;
			//Get the time in the payload.
		if(this->count>START_COUNT && this->count<=START_COUNT+ARRAY_SIZE){
			char * payload=nbEvent->getContentPayload();
			int length=nbEvent->getPayloadLength();
					
			long long offset=0;
			long long time=Utils::readLong(payload,offset);
			//cout<<"Time = "<<time<<endl;			
			
			//string msg(payload+offset,length-offset);
			//cout<<"Message = "<<msg<<endl;		
		
			//Convert it to long long		
			//long long time=atoll(payload); // Alternative std::istringstream ss_port(*argv++); ss_port >> port;  
			//Get the current time
			long long curTime=Utils::getCurrentTimeMicroseconds();
			//Time difference in micro seconds
			long long diffmicro=(curTime-time);	
			//cout<<diffmicro<<endl;			
			
			delete[] payload;
			
			this->times[this->count-START_COUNT-1]=diffmicro;
			if(count%(START_COUNT+ARRAY_SIZE)==0){
				for(int i =0;i<ARRAY_SIZE;i++){
					cout<<this->times[i]<<endl;					
				}
			}
		}
	}
	
	private:
		long long totalTime;
	    int count;
	    long long times[ARRAY_SIZE] ;
};



int main(int argc, char **argv){
	cout<<"///////////////////////BMReceiver////////////////////////"<<endl;

	if(argc!=5){
		cout<<"Usage : [host][port][entityId][topic]"<<endl;
		exit(1);	
	}
	/*Ignore the first argument */
	*argv++;	
	string host=*argv++;
	int port=5045;
	std::istringstream ss_port(*argv++);
	ss_port >> port;	
	
	int entityId=0;
	std::istringstream ss(*argv++);
    ss >> entityId;
	string contentSynopsis=*argv++;
	
	if(entityId<=0|| contentSynopsis.length()<=0){
		cout<<"Usage : [host][port][entityId][topic]"<<endl;
		exit(1);	
	}
	
	
	int templateId=55745;
			
	ServiceClient serviceClient;
	serviceClient.init(host,port,entityId,templateId);
	
	MyCallback callback;
	serviceClient.subscribe(contentSynopsis,&callback);
	cout<<"====================Benchmark Receiver============="<<endl;
	cout<<"Type any number of messages and <return key>"<<endl;
	cout<<"To exit type .<return key>"<<endl;
	cout<<"==================================================="<<endl;
	
	char msg[256]="";
	string str="";
	while (str!="."){
        cin.getline(msg, 256);
		str=msg;
		if(!(str==".")){
			cout<<"Invalid input. To exit type .<return key>"<<endl;
		}
	}
	
	serviceClient.cleanup();
	
}
