/***************************************************************************
 *  Copyright:http://www.naradabrokering.org/index.html
 *  Author: Jaliya Ekanayake
 *  Email : jaliyae@gmail.com
 ****************************************************************************/
#include <iostream>
#include <fstream>
#include "ServiceClient.h"
#include "Profile.h"
#include "Utils.h"

using namespace std;

int main(int argc, char **argv) {
	
	cout<<"///////////////////////TestClient////////////////////////"<<endl;
	cout<<argc<<endl;
	if (argc!=7) {
		cout<<"Usage : [host][port][entityId][topic][header][file name]"<<endl;
		exit(1);
	}
	//Ignore the first argument 
	*argv++;

	//host
	string host=*argv++;

	//port
	int port=0;
	std::istringstream ss_port(*argv++);
	ss_port>>port;

	//entityId
	int entityId=0;
	std::istringstream ss_entityId(*argv++);
	ss_entityId >> entityId;

	string contentSynopsis=*argv++;	
	string header=*argv++;
	string fileName=*argv++;

	if (entityId<=0|| contentSynopsis.length()<=0 ||fileName.length()<=0) {
		cout<<"Usage : [host][port][entityId][topic][header][file name]"<<endl;
		exit(1);
	}

	int templateId=55745;
	//string contentSynopsis="/abc/cpp/test";
	ifstream::pos_type size;
	char * memblock;
	
	int length_of_mem_block=8+4+header.length();//[long long timestam][int header_length][bytes header]
	

	ifstream file(fileName.c_str(), ios::in|ios::binary|ios::ate);
	if (file.is_open()) {
		size = file.tellg();
		length_of_mem_block=length_of_mem_block+(int)size;//
		memblock = new char [length_of_mem_block];
		
		long long offset=0;
		
		long long time=Utils::getCurrentTimeMicroseconds();		
		Utils::writeLong(memblock+offset, time, offset); //timestamp		
		Utils::writeInt(memblock+offset, header.length(), offset);//length of header part
		Utils::writeBytes(memblock+offset, header.c_str(), header.length(),offset);//header part
		
				
		file.seekg(0, ios::beg);
		file.read(memblock+offset, size);
		file.close();	
		

		//cout << "the complete file content is in memory";
		ServiceClient serviceClient;
		serviceClient.init(host, port, entityId, templateId);
		cout<<"Publishing = "<<contentSynopsis<<"*   *"<<fileName<<endl;
		serviceClient.publish(contentSynopsis,memblock,length_of_mem_block);
		
		string abc="abc";
		serviceClient.publish(contentSynopsis,(char*)abc.c_str(),abc.length());
		
		cout<<"publishing string"<<endl;

		delete[] memblock;
		serviceClient.cleanup();
	} else {
		cout << "Unable to open file";
	}

	//string txt="This is my text message ";
	//serviceClient.publish(contentSynopsis,(char *)txt.c_str(),txt.length());
	 
	 
	 

}
