/***************************************************************************
 *  Copyright:http://www.naradabrokering.org/index.html
 *  Author: Jaliya Ekanayake
 *  Email : jaliyae@gmail.com
 ****************************************************************************/
#include <iostream>
#include "ServiceClient.h"
#include "Profile.h"
#include "Utils.h"

using namespace std;


class MyCallback : public Callback
{
public:
    MyCallback()
    {}

    void onEvent(NBEvent *nbEvent)
    {
        char * payload=nbEvent->getContentPayload();
        int length=nbEvent->getPayloadLength();

        long long offset=0;
        long long time=Utils::readLong(payload,offset);
        long long curTime=Utils::getCurrentTimeMicroseconds();
        long long diffmicro=(curTime-time);		
			
        int header_len=Utils::readInt(payload+offset,offset);
        char header[header_len];
        Utils::copyBytes(payload+offset,header,header_len,offset);
	
        string header_str(header);
          
        cout<<"Timestamp :"<<time<<endl;
        cout<<"Header :"<<header_str<<endl;
		
        delete[] payload;

    }

};



int main(int argc, char **argv)
{
    cout<<"///////////////////////BMReceiver////////////////////////"<<endl;

    if(argc!=5)
    {
        cout<<"Usage : [host][port][entityId][topic]"<<endl;
        exit(1);
    }
    /*Ignore the first argument */
    *argv++;
    string host=*argv++;
    int port=5045;
    std::istringstream ss_port(*argv++);
    ss_port >> port;

    int entityId=0;
    std::istringstream ss(*argv++);
    ss >> entityId;
    string contentSynopsis=*argv++;

    if(entityId<=0|| contentSynopsis.length()<=0)
    {
        cout<<"Usage : [host][port][entityId][topic]"<<endl;
        exit(1);
    }


    int templateId=55745;

    ServiceClient serviceClient;
    serviceClient.init(host,port,entityId,templateId);

    MyCallback callback;
    serviceClient.subscribe(contentSynopsis,&callback);
    cout<<"====================Benchmark Receiver============="<<endl;
    cout<<"Type any number of messages and <return key>"<<endl;
    cout<<"To exit type .<return key>"<<endl;
    cout<<"==================================================="<<endl;

    char msg[256]="";
    string str="";
    while (str!=".")
    {
        cin.getline(msg, 256);
        str=msg;
        if(!(str=="."))
        {
            cout<<"Invalid input. To exit type .<return key>"<<endl;
        }
    }

    serviceClient.cleanup();

}
