/***************************************************************************
 *  Copyright:http://www.naradabrokering.org/index.html
 *  Author: Jaliya Ekanayake
 *  Email : jaliyae@gmail.com
 ****************************************************************************/
#include <iostream>
#include "ServiceClient.h"
#include "Profile.h"

using namespace std;

class MyCallback : public Callback
{
	void onEvent(NBEvent *nbEvent){
		cout<<"------------Event Rececived with the following information---------- "<<endl;
		cout<<"Topic  = "<<nbEvent->getContentSynopsis()<<endl;
		char * payload=nbEvent->getContentPayload();
		int payloadSize=nbEvent->getPayloadLength();
		cout<<"Payload = ";
		for(int i=0;i<payloadSize;i++){
			printf("%c",*(payload+i));	
		}
		cout<<endl<<"--------------------------------------------------------------------- "<<endl;
	}
};


int main(int argc, char **argv){
	cout<<"///////////////////////TestClient////////////////////////"<<endl;

	if(argc!=3){
		cout<<"Usage : [entityId][topic]"<<endl;
		exit(1);	
	}
	/*Ignore the first argument */
	*argv++;	
	int entityId=0;
	std::istringstream ss(*argv++);
    ss >> entityId;
	string contentSynopsis=*argv++;
	
	if(entityId<=0|| contentSynopsis.length()<=0){
		cout<<"Usage : [entityId][topic]"<<endl;
		exit(1);	
	}
	
	
	int templateId=55745;
	string contentSynopsis1=contentSynopsis+"/1";
	string contentSynopsis2=contentSynopsis+"/2";
	string contentSynopsis3=contentSynopsis+"/3";
	string contentSynopsis4=contentSynopsis+"/4";
			
	ServiceClient serviceClient;
	serviceClient.init("127.0.0.1",5045,entityId,templateId);
	
	MyCallback callback;
	serviceClient.subscribe(contentSynopsis1,&callback);
	serviceClient.subscribe(contentSynopsis2,&callback);
	serviceClient.subscribe(contentSynopsis3,&callback);
	serviceClient.subscribe(contentSynopsis4,&callback);
	cout<<"====================Simple Chat Client============="<<endl;
	cout<<"Type any number of messages and <return key>"<<endl;
	cout<<"To exit type .<return key>"<<endl;
	cout<<"==================================================="<<endl;
	
	char msg[256]="";
	string str="";
	while (str!="."){
        cin.getline(msg, 256);
		str=msg;
		if(!(str=="."))
		serviceClient.publish(contentSynopsis1,msg,strlen(msg));		
		serviceClient.publish(contentSynopsis2,msg,strlen(msg));	
		serviceClient.publish(contentSynopsis3,msg,strlen(msg));	
		serviceClient.publish(contentSynopsis4,msg,strlen(msg));	
	}
	
	serviceClient.cleanup();
	
}
