/***************************************************************************
 *  Copyright:http://www.naradabrokering.org/index.html
 *  Author: Jaliya Ekanayake
 *  Email : jaliyae@gmail.com
 ****************************************************************************/
#include "NBCEnvelope.h"
#include "Utils.h"
#include "constants.h"

NBCEnvelope::NBCEnvelope(){}
NBCEnvelope::~NBCEnvelope(){
	cout<<"Destructing the NBCEnvelope "<<endl;
	delete[] payload;
	delete[] signature;	
	delete [] cert;
}


int
NBCEnvelope::getSerializedLength(){
	//cout<<"Returning size of NBCEnvelope SIZE+payload+cert+signature"<<SIZE_OF_MSG<<" + "<<payload_length<<" +"<<this->cert_length<<" + "<<signature_length<<endl;
	return SIZE_OF_MSG + this->payload_length+this->cert_length+this->signature_length;
	
}	

bool
NBCEnvelope::fromBytes(char *bytes){
	 long long offset = 0;
 	  	
 	/*Validate the first two bytes*/
 	if(CLARENS_DATA!=Utils::readByte(bytes+offset,offset)) {return false;} ;
	if(NB_CLARENS_MESSAGE!=Utils::readByte(bytes+offset,offset)) {return false;} ;
	
	/*Secure message or not*/
	this->secure=Utils::readBool(bytes+offset,offset);
	
	/*Reading payload*/
	this->payload_length = Utils::readInt(bytes+offset,offset);	
	char *payload=new char[payload_length];
	Utils::copyBytes((bytes+offset),payload,payload_length,offset);
	this->payload=payload;
	 	 
	/*Reading signature*/
	this->signature_length = Utils::readInt(bytes+offset,offset);
	char *signature=new char[signature_length];
	Utils::copyBytes((bytes+offset),signature,signature_length,offset);
	this->signature=signature;
	  
	 /*Reading the certificate*/
	 this->cert_length = Utils::readInt(bytes+offset,offset);
	 this->cert= new char[cert_length];
	 Utils::copyBytes((bytes+offset),cert,cert_length,offset);	
	 return true;
}

void
NBCEnvelope::getBytes(char *buff,int *length){
	 long long offset = 0;
	 /*Headerse*/
	 Utils::writeByte(buff+offset,(char)CLARENS_DATA,offset);
     Utils::writeByte(buff+offset,(char)NB_CLARENS_MESSAGE,offset);
     
     /*Secure or not*/
     //cout<<"Writing secure/not ="<<secure<<endl;     
     Utils::writeBool(buff+offset,secure,offset);
     
     /*Payload*/
   //  cout<<"Writing payload ="<<payload_length<<endl;     
     Utils::writeInt(buff+offset,this->payload_length,offset);
     Utils::writeBytes(buff+offset,payload,this->payload_length,offset);
     
     /*Signature*/
    // cout<<"Writing signature ="<<this->signature_length<<endl;     
     Utils::writeInt(buff+offset,this->signature_length,offset);
     Utils::writeBytes(buff+offset,signature,this->signature_length,offset);
     
     /*Certificate*/
    // cout<<"Writing Certificate ="<<this->cert_length<<endl; 
     Utils::writeInt(buff+offset,this->cert_length,offset);
     Utils::writeBytes(buff+offset,cert,this->cert_length,offset);
     //Now set the length
     (*length)=offset;          
}

void 
NBCEnvelope::getCertificate(X509 **x509_cert) 
{
	 
	 //X509 *x;
	 unsigned char *buf, *p;
	
	 int length;
	
	 /* Something to setup buf and len */
	 buf=(unsigned char *)this->cert;
	 length=this->cert_length;
	
	 p = buf;
	
	 (*x509_cert) = d2i_X509(NULL, (const unsigned char **)&p, length);
	
	 if ((*x509_cert) == NULL){
		 cout<<"$$$$$$$$$Error in getting the certificate "<<endl;
	 }
	    /* Some error */
	
	
	
	/*
	EVP_PKEY * agent_pub_key = X509_get_pubkey (*x509_cert);
	X509_free (*x509_cert);
    	if (!agent_pub_key)
   		 { 
			//    	    unsigned long err = ERR_get_error ();
			//     	   m_error = string ("Could not read user public key:\n")
			//                  + ERR_reason_error_string (err);
			//      	  return m_initialized;
			cout<<"ERROR: Reading the agent's certificate to get the pubkey"<<endl;
   		 }
	
	
	EVP_MD_CTX vctx;
	EVP_MD_CTX_init(&vctx);
	EVP_VerifyInit_ex(&vctx, EVP_sha1(), NULL);
	
	EVP_VerifyUpdate(&vctx,this->payload ,this->payload_length);
		
		int ret = EVP_VerifyFinal(&vctx, (unsigned char *)this->signature, this->signature_length, agent_pub_key);
        if (ret == 1)
        {
                std::cout << "Signature is valid" << std::endl;
        }
        else if (ret == 0)
                std::cout << "Signature is invalid..." << std::endl;
        else
                std::cout << "Verification failed..." << std::endl;*/
	
	
//------------------------------------------

}
