/***************************************************************************
 *  Copyright:http://www.naradabrokering.org/index.html
 *  Author: Jaliya Ekanayake
 *  Email : jaliyae@gmail.com
 ****************************************************************************/
#include <iostream>
#include <string>
#include <map>
#include "ServiceClient.h"
#include "Profile.h"

using namespace std;

#define SESSION_MGT_TOPIC "/test/session_mangement"

const static string SES_INFO_SUB="ses_info_sub";
const static string SES_NAME_REQ="ses_name_req";
const static string SES_NAME_RES="ses_name_res";
const static string SES_DATA_REQ="ses_data_req";
const static string SES_DATA_RES="ses_data_res";

class AgentCallback : public Callback{
	public:
		void init();
		void onEvent(NBEvent *nbEvent);
	private:		
		string ses_name;
		string ses_data;
		ServiceClient sClient; 
};

	
void 
AgentCallback::init(){
		srand((unsigned) time(0));
		int templateId=55745;
		int entityID = (rand() % 10000) + 10000;
		this->sClient.init("156.56.104.95", 5045, entityID, templateId);
};
	
void
AgentCallback::onEvent(NBEvent *nbEvent) {
		cout<<"------------Event Rececived with the following information---------- "<<endl;
		cout<<"Topic  = "<<nbEvent->getContentSynopsis()<<endl;
		char * payload=nbEvent->getContentPayload();
		int payloadSize=nbEvent->getPayloadLength();
		 cout<<"Payload = ";
		 for(int i=0;i<payloadSize;i++)
		 {
		    printf("%c",*(payload+i));
		 }
		cout<<endl<<"--------------------------------------------------------------------- "<<endl;
		
		 string msg(payload,payloadSize);
	    //First find the type of the message
	    int offset=0;
	    int index_one=msg.find("|");
	    if(index_one==string::npos)
	    {
	        return;
	    } //Not for me.
	    string msg_type=msg.substr(offset,index_one-offset);
	    offset+=index_one+1;
	    cout<<"Message Type = "<<msg_type<<endl;
	
	    if(msg_type.compare(SES_INFO_SUB)==0)
	    {
	    	//msg format=> ses_info_sub|session_name|content
	    	int index_two=msg.find("|",offset);
	        if(index_two==string::npos)
	        {
	            return;
	        }
	        string session_name=msg.substr(offset,index_two-offset);
	        offset=index_two+1;
	        
	        string session_data=msg.substr(offset);
	        
	        cout<<"Session Name ="<<session_name<<"  Session Data "<<session_data<<endl;
       		this->ses_name= session_name;
       		this->ses_data=session_data;    
	    	
	    	
	    }else if(msg_type.compare(SES_NAME_REQ)==0){
	    	//msg format=> ses_info_sub|session_name|content	    	
	        string response_topic=msg.substr(offset);
	        cout<<"Response Topic for sesion name "<<response_topic<<endl;
	        
	        stringstream buff;
	        buff<<SES_NAME_RES;
	        buff<<"|";
	        buff<<this->ses_name;
	        
	        sClient.publish(response_topic,(char*)(buff.str().c_str()),strlen(buff.str().c_str()));
	        
	    }else if(msg_type.compare(SES_DATA_REQ)==0){
	    	string response_topic=msg.substr(offset);
	        cout<<"Response Topic for session data"<<endl;
	        
	        stringstream buff;
	        buff<<SES_DATA_RES;
	        buff<<"|";
	        buff<<this->ses_data;
	        
	        sClient.publish(response_topic,(char*)(buff.str().c_str()),strlen(buff.str().c_str()));
	    }else{
	    	return;
	    }	
		
		
};
	
	




int main(int argc, char **argv) {
	cout<<"///////////////////////TestClient////////////////////////"<<endl;	

	srand((unsigned) time(0));
	int templateId=55745;
	//for (int i=0; i<12; i++) {		
		int entityID = (rand() % 10000) + 10000;
		//string contentSynopsis="/abc/cpp/test";

		ServiceClient *serviceClient = new ServiceClient();
		serviceClient->init("156.56.104.95", 5045, entityID, templateId);

		AgentCallback *callback=new AgentCallback();
		callback->init();
		serviceClient->subscribe(SESSION_MGT_TOPIC, callback);
	//}
	cout<<"====================Simple Chat Client============="<<endl;
	cout<<"Type any number of messages and <return key>"<<endl;
	cout<<"To exit type .<return key>"<<endl;
	cout<<"==================================================="<<endl;

	char msg[256]="";
	string str="";
	while (str!=".") {
		cin.getline(msg, 256);
		str=msg;
		if (!(str==".")) {
			for (int i=0; i<1; i++) {
				cout<<i<<endl;
				//serviceClient->publish(contentSynopsis,msg,strlen(msg));
			}
		}
	}

	//serviceClient.cleanup();

}
