/***************************************************************************
 *  Copyright:http://www.naradabrokering.org/index.html
 *  Author: Jaliya Ekanayake
 *  Email : jaliyae@gmail.com
 ****************************************************************************/
#include "ROOTCallback.h"
#include "TROOT.h"
#include "TSystem.h"
#include "Api.h"
#include "TString.h"

#include "Class.h"
#include "BaseCls.h"
#include "Type.h"
#include "Method.h"
#include "MethodAr.h"
#include "DataMbr.h"
#include "CallFunc.h"
#include "Typedf.h"

#include <iostream>
#include <string>

using namespace std;

ROOTCallback::ROOTCallback(TCallback *tCallback):tCallback(tCallback){

}

ROOTCallback::~ROOTCallback(){
	
}

void
ROOTCallback::onEvent(NBEvent *nbEvent){
	
	int a = pthread_mutex_lock(&t_mutex);
	
	//cerr<<"----------Event Rececived with the following information---------- "<<endl;
	//cerr<<"Topic  = "<<nbEvent->getContentSynopsis()<<endl;
	char * payload=nbEvent->getContentPayload();
	int payloadSize=nbEvent->getPayloadLength();
	string str(payload,payloadSize);
	//cout<<str<<endl;
	
    char *pbytes = (char *) malloc(payloadSize);
	memcpy(pbytes,payload,payloadSize);
    delete[] payload;

	///Call the callback function using the reflection mechanism provided by the ROOT
	G__CallFunc func;
	G__ClassInfo cl(this->tCallback->getClassName().c_str());
	
	Long_t offset;	
	//char temp[128];
	//char *temp = (char *) malloc(128);
	char *temp=new char[128];
	//sprintf(temp,"(void **)%-p,(char *)%-p,(int)%d",this->tCallback->getArgs(),payload,payloadSize);
	sprintf(temp,"(void **)%-p,(char *)%-p,(int)%d",this->tCallback->getArgs(),pbytes,payloadSize);
		
	int error=0;
	
	func.SetFunc(&cl,this->tCallback->getMethodName().c_str(),temp,&offset);
	func.Exec(0);
	
	if(error) error=G__lasterror();
	//cerr<<"-------------Finished Executing the CALLBACK------------------------"<<endl;
	//free(temp);
	delete [] temp;
	int d = pthread_mutex_unlock(&t_mutex);	
}

