/***************************************************************************
 *  Copyright:http://www.naradabrokering.org/index.html
 *  Author: Jaliya Ekanayake
 *  Email : jaliyae@gmail.com
 ****************************************************************************/
#include <iostream>
#include <string>
#include "TString.h"
#include "TRootletHelper.h"

ClassImp(TRootletHelper)

TRootletHelper::~TRootletHelper() {}
/*
 * Format of the line: 
 * analysis_script.C|born1.root,born2.root,...,bornn.root|output.histo|/clarens/rootlet/test1
 * 1.Script Name : analysis_script.C
 * 2.Comma separated input file list : born1.root,born2.root,...,bornn.root
 * 3.Ouput file : output.histo
 * 4.Response Topic : /clarens/rootlet/test1
 * */
bool 
TRootletHelper::getTLineString(char *tline) {
	if (this->resposeTopic.empty()||this->outputFileName.empty()
			||this->scriptName.empty()||this->inputFileNames.empty()) {
		return false;
	} else {
		TString Tline("");
		Tline+=scriptName;
		Tline+="|";
		
		int numInputFiles=inputFileNames.size();
		for(int i=0;i<numInputFiles;i++){
			if (i!=(numInputFiles-1))
				Tline+=inputFileNames[i]+",";
			else
				Tline+=inputFileNames[i];
		}

		Tline+="|";
		Tline+=outputFileName;
		Tline+="|";
		Tline+=this->resposeTopic;
		
		strcat(tline,Tline.Data());
		
		return true;
	}
}

