/***************************************************************************
 *  Copyright:http://www.naradabrokering.org/index.html
 *  Author: Jaliya Ekanayake
 *  Email : jaliyae@gmail.com
 ****************************************************************************/
#include <iostream>
#include <string>
#include "ClientCall.h"
#include "ClientContext.h"
#include "AgentConfig.h"
#include "ServiceException.h"
#include "Utils.h"
#include "limits.h"


void testTimer(){
		for(int i=0;i<10;i++){
		long long start=Utils::getCurrentTimeMicroseconds();
		usleep(1000000);
		long long end=Utils::getCurrentTimeMicroseconds();
		long long gap=(end-start);
		cout<<"Start ="<<start<<"   End = "<<end<<"  Gap = "<<gap<<endl;
	}
	
	cout<<INT_MAX<<endl;
	cout<<LONG_MAX<<endl;
}

int main(){
	
	//string configFile="/home/jaliya/projects/clarens/cpp/config/client_config.txt";
	string configFile="/home/jaliya/projects/cppworkspace/nbcpp/config/client_config.txt";
	
	
	ClientContext ctx;
	AgentConfig cfg(configFile);	
	try{	
		cfg.getConfiguration(&ctx);	
	}catch(ServiceException& e){
		throw("Coud not initialize the AgentServiceClient "+e.getMessage());
	}
	

	ClientCall call;
	call.init(&ctx);
	int count=0;
	while(true){
		cout<<"=============== Cycle ======== "<<++count<<"=========="<<endl;
		int num_return=0;
		char **responses = new char * [1];
		string subTopic=Utils::getCurrentTimeMicroAsString();
		//We wait for only one response
		call.sendReceive("INTIAL_ENTRY_TOPIC",subTopic,(char *)subTopic.c_str(),subTopic.size(),1,responses,&num_return);	
		
		if(num_return>0){		
			cout<<"Received Response "<<endl;		
			/*Delete the response array*/
			for(int i =0;i<1;i++){
				/*These are the payloads of the nbevents received*/
				delete [] (responses[i]);
			}
			delete[] responses;		
	
		
		}else{
			/*Delete the response array*/
			delete[] responses;
			cout<<"Could not discover any agent..."<<endl;	
		}
		usleep(100);
	}
return 0;

}
